#!/usr/bin/perl
# program prevadi datove soubory z C-MuniPacku standardniho fot. systmu BVRcIc
#
# ZPSOB POUIT: > conv2std.pl Bfile Vfile Rfile Ifile
#
# Pokud mte mn filtr - nap. jen VRI, i RI, VR, VI, zadejte msto 
# chybjcch filtr pomlku nap: > conv2std.pl - Vfile Rfile - (= mte jen filtry V a R)
#
# V ppad pot kontaktujte autora - L. Brt, brat@pod.snezkou.cz
# Bc. Lubo Brt, v Peci pod Snkou 25.12.2008
#
# Zadejte sv koeficienty: 

$Cb = 1.387;
$Cv = -0.160;
$Cr = -1.003;
$Ci = -0.954;
$Cri = -0.006; 	# koeficienty pro ppad, e nemme men ve filtru V, ale jen R a I
$Cir = -0.902;	# koeficienty pro ppad, e nemme men ve filtru V, ale jen R a I

#
# POZOR!!! DLEIT UPOZORNN: V݊E UVEDEN KOEFICIENTY MUSTE MT URENY PESN PRO VAI 
# MC SOUSTAVU. DN JIN HODNOTY KOEFICIENT NELZE POUT!
# 
# plat pro rovnice 
# dB = dv + Cb*(db - dv)
# dV = dv + Cv*(dv - dr)
# dR = dv + Cr*(dv - dr)
# dI = dv + Ci*(dv - di)
# dR = dr + Cri*(dr - di)
# dI = dr + Cir*(dr - di)
#
# POKUD BYSTE MLI NAPROSTO STANDARDN SOUSTAVU, POTOM PLAT, E Cb = 1, Cv = 0, Cr = -1, 
# Ci = -1, Cri = 0 a Cir = -1. 
#
#
# rozsah z jakho se m prmrovat bod z pomocn ady ve dnech

$pas = 0.002; 

# Zadejte hodnoty 0.1 a 0.001 podle povahy svteln kivky. 
# m krat vykazuje svteln kivka variace, tm krat je teba zvolit ps.
#
#
######## DO NOT EDIT BELLOW THIS LINE #########################################################

use File::Copy;

$Bfile = $ARGV[0];
$Vfile = $ARGV[1];
$Rfile = $ARGV[2];
$Ifile = $ARGV[3];


# read data in selected filter
sub read_data {
	my ($file, $filter) = @_;
	my $i;
	open (F, "<".$file) || die $!;
	$i = 0;
	while (<F>) {
		chop; 
		if ($_ =~ /^24/) {
			($jd, $mag, $err) = split (/\s+/, $_);
			if ($mag < 90) { 
				$$filter[$i] = $jd." ".$mag." ".$err;
				++$i;
			}
		}
	}
}

# funkce pro vypocet prumeru z druheho filtru
sub count_pom_ave {
	my ($rarray, $band, $jd, $pas) = @_;
	my $magsum, $magcount, $i;
	my $len;
	$len = @$rarray; 
	$magsum = 0; $magcount = 0; 
	foreach $row (@$band) {
		($tmpjd, $tmpmag, $tmperr) = split (/\s+/, $row);
		$vzdalenost = abs($tmpjd - $jd);
		if ($vzdalenost <= $pas) {
			$magsum += $tmpmag;
			++$magcount;
		}
	}
	if ($magcount > 0) { 
		return $magsum / $magcount; 
	} else {
		return 0;
	}
}


if ($Bfile ne "-") { 
	read_data($Bfile, "B"); 
	copy($Bfile, $Bfile.".inst") or die $!;
	$Bstate = 1;
} else {
	$Bstate = 0;
}

if ($Vfile ne "-") { 
	read_data($Vfile, "V"); 
	copy($Vfile, $Vfile.".inst") or die $!;
	$Vstate = 1;
} else {
	$Vstate = 0;
}

if ($Rfile ne "-") { 
	read_data($Rfile, "R"); 
	copy($Rfile, $Rfile.".inst") or die $!;
	$Rstate = 1;
} else {
	$Rstate = 0;
}

if ($Ifile ne "-") { 
	read_data($Ifile, "I"); 
	copy($Ifile, $Ifile.".inst") or die $!;
	$Istate = 1;
} else {
	$Istate = 0;
}

$totalstate = $Bstate + $Vstate + $Rstate + $Istate;

if ($totalstate < 2) {
	print "Pro pevod instrumentlnch hodnot do standardnho systmu BVRcIc \n";
	print "muste mt hodnoty alespo ve dvou filtrech!\n\n";
	exit;
}

if ($Bstate && $Vstate) { 
	# prepocet b -> B, dB = dv + Cb*(db - dv)
	open (OUTB, ">".$Bfile) || die $!;
	print OUTB "# Data transformed to Johnson-Cousins BVRcIc system\n";
	print OUTB "# Transformation coeficient Cb = ".$Cb." was used in equation: dB = dv + Cb*(db - dv)\n";
	print OUTB "# dv value counted as average in V band around +/- ".$pas." days for each db point.\n\n";
	for ($j = 0; $j< @B; $j++) {
		($jd, $mag, $err) = split (/\s+/, $B[$j]);
		$pomv = count_pom_ave(\@V, "V", $jd, $pas);
		if (!$pomv) { 
			print OUTB "No comparation data found in V band +/- ".$pas." days around the point\n";
		} else {
			$stdB = $pomv + $Cb*($mag - $pomv);
			print OUTB $jd."  ".sprintf("%.4f", $stdB)."  ".$err."\n";
		}
	}
	close (OUTB);
} 

if ($Vstate && $Rstate) { 
	# prepocet v -> V, dV = dv + Cv*(dv - dr)
	open (OUTV, ">".$Vfile) || die $!;
	print OUTV "# Data transformed to Johnson-Cousins BVRcIc system\n";
	print OUTV "# Transformation coeficient Cv = ".$Cv." was used in equation: dV = dv + Cv*(dv - dr)\n";
	print OUTV "# dr value counted as average in R band around +/- ".$pas." days for each dv point.\n\n";
	for ($j = 0; $j< @V; $j++) {
		($jd, $mag, $err) = split (/\s+/, $V[$j]);
		$pomr = count_pom_ave(\@R, "R", $jd, $pas);
		if (!$pomr) { 
			print OUTV "No comparation data found in R band +/- ".$pas." days around the point\n";
		} else {
			$stdV = $mag + $Cv*($mag - $pomr);
			print OUTV $jd."  ".sprintf("%.4f", $stdV)."  ".$err."\n";
		}
	}
	close (OUTV);
}

if ($Vstate && $Rstate) { 
	# prepocet r -> R, dR = dv + Cr*(dv - dr)
	open (OUTR, ">".$Rfile) || die $!;
	print OUTR "# Data transformed to Johnson-Cousins BVRcIc system\n";
	print OUTR "# Transformation coeficient Cr = ".$Cr." was used in equation: dR = dv + Cr*(dv - dr)\n";
	print OUTR "# dv value counted as average in V band around +/- ".$pas." days for each dr point.\n\n";
	for ($j = 0; $j< @R; $j++) {
		($jd, $mag, $err) = split (/\s+/, $R[$j]);
		$pomv = count_pom_ave(\@V, "V", $jd, $pas);
		if (!$pomv) { 
			print OUTR "No comparation data found in V band +/- ".$pas." days around the point\n";
		} else {
			$stdR = $pomv + $Cr*($pomv - $mag);
			print OUTR $jd."  ".sprintf("%.4f", $stdR)."  ".$err."\n";
		}
	}
	close (OUTR);
}


if ($Vstate && $Istate) { 
	# prepocet i -> I, dI = dv + Ci*(dv - di)
	open (OUTI, ">".$Ifile) || die $!;
	print OUTI "# Data transformed to Johnson-Cousins BVRcIc system\n";
	print OUTI "# Transformation coeficient Ci = ".$Ci." was used in equation: dI = dv + Ci*(dv - di)\n";
	print OUTI "# dv value counted as average in V band around +/- ".$pas." days for each di point.\n\n";
	for ($j = 0; $j< @I; $j++) {
		($jd, $mag, $err) = split (/\s+/, $I[$j]);
		$pomv = count_pom_ave(\@V, "V", $jd, $pas);
		if (!$pomv) { 
			print OUTI "No comparation data found in V band +/- ".$pas." days around the point\n";
		} else {
			$stdI = $pomv + $Ci*($pomv - $mag);
			print OUTI $jd."  ".sprintf("%.4f", $stdI)."  ".$err."\n";
		}
	}
	close (OUTI);
}


if ($Rstate && $Istate && !$Vstate) {
	# prepocet r -> R, dR = dr + Cri*(dr - di)
	open (OUTR, ">".$Rfile) || die $!;
	print OUTR "# Data transformed to Johnson-Cousins BVRcIc system\n";
	print OUTR "# Transformation coeficient Cri = ".$Cri." was used in equation: dR = dr + Cri*(dr - di)\n";
	print OUTR "# di value counted as average in I band around +/- ".$pas." days for each dr point.\n\n";
	for ($j = 0; $j< @R; $j++) {
		($jd, $mag, $err) = split (/\s+/, $R[$j]);
		$pomi = count_pom_ave(\@I, "I", $jd, $pas);
		if (!$pomi) { 
			print OUTR "No comparation data found in I band +/- ".$pas." days around the point\n";
		} else {
			$stdR = $mag + $Cri*($mag - $pomi);
			print OUTR $jd."  ".sprintf("%.4f", $stdR)."  ".$err."\n";
		}
	}
	close (OUTR);


	# prepocet i -> I, dI = dr + Cir*(dr - di)
	open (OUTI, ">".$Ifile) || die $!;
	print OUTI "# Data transformed to Johnson-Cousins BVRcIc system\n";
	print OUTI "# Transformation coeficient Cir = ".$Cir." was used in equation: dI = dr + Cir*(dr - di)\n";
	print OUTI "# dr value counted as average in R band around +/- ".$pas." days for each di point.\n\n";
	for ($j = 0; $j< @I; $j++) {
		($jd, $mag, $err) = split (/\s+/, $I[$j]);
		$pomr = count_pom_ave(\@R, "R", $jd, $pas);
		if (!$pomr) { 
			print OUTI "No comparation data found in R band +/- ".$pas." days around the point\n";
		} else {
			$stdI = $pomr + $Cir*($pomr - $mag);
			print OUTI $jd."  ".sprintf("%.4f", $stdI)."  ".$err."\n";
		}
	}
	close (OUTI);

}

